.586
;.XMM
.model flat,stdcall
option casemap:none

	include synth.inc

.data
	szClassName	db "MainWinClass",0
	szEditClass	db "EDIT",0

	szAppName	db "Sound synth",0

	szInfoCaption	db "Info",0
	szInfoFormat	db "%lu loops",0Dh,0Ah
			db "%lu samples",0Dh,0Ah
			db "%lu generate cycles per sample",0Dh,0Ah
			db "%lu filter cycles per sample.",0

	dPlayState	dd 0
	szStart		db "Start",0
	szStop		db "Stop",0

	dwScopeRate	dd DEF_SCOPE_RATE

	dwSampleRate	dd 44100
	fSampleRate	REAL4 44100.0
	f2		REAL4 2.0
	f2PI		REAL4 0.0
	fMaxAmp		REAL4 32767.0
	fW		REAL4 0.0
	
	scope		CANVAS <>
	dwScopeWindowW	dd BUFFER_SIZE

	dwPanel		dd 0

	dwWidth		dd 0
	dwHeight	dd 0
	
	dFilterOn	dd 0

ALIGN 4

	dwGenCycles	dd 0
	dwFilterCycles	dd 0
	dwLoops		dd 0

	dwFilterOn	dd BST_UNCHECKED

	lpBufferStart	dd ?
	lpBufferEnd	dd ?
	lpBufferPlayPos	dd ?
	lpBufferGenPos	dd ?
	lpStr		dd ?

	hInstance	HINSTANCE ?
	hMainWnd	HANDLE ?
	hPanel		HANDLE 4 dup (?)

	Rect		RECT <>
	lpDefEditProc	dd ?

.code
start:
	invoke GetModuleHandle, NULL
	mov	hInstance,eax

	invoke GlobalAlloc,GPTR,100h
	mov	lpStr,eax

	finit

	fldpi
	fmul	f2
	fst	f2PI
	fdiv	fSampleRate
	fstp	fW				; w=2*PI/sampleRate

	invoke WinMain, hInstance,NULL,NULL,SW_SHOWDEFAULT

;	mov	ecx,dwLoops
;	or	ecx,ecx
;	jz @Exit
;		push	ebx
;
;		mov	ebx,dwLoops		; total coount of loops
;		mov	eax,BUFFER_SIZE
;		mul	ebx	
;		mov	ecx,eax			; total count of samples
;		mov	eax,dwFilterCycles
;		xor	edx,edx
;		div	ecx
;		push	eax
;		mov	eax,dwGenCycles
;		xor	edx,edx
;		div	ecx
;		push	eax	
;		push	ecx
;		push	ebx
;		push	offset szInfoFormat
;		push	lpStr
;		call wsprintf
;		;invoke MessageBox,NULL,lpStr,offset szInfoCaption,MB_OK
;		pop	ebx
@Exit:
	invoke GlobalFree,lpStr
	invoke ExitProcess,eax


WinMain		PROC hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
LOCAL wc:WNDCLASSEX
LOCAL msg:MSG

		mov	wc.cbSize,SIZEOF WNDCLASSEX
		mov	wc.style, CS_HREDRAW or CS_VREDRAW
		mov	wc.lpfnWndProc, OFFSET WndProc
		mov	wc.cbClsExtra,NULL
		mov	wc.cbWndExtra,NULL
		m2m	wc.hInstance,hInstance
		mov	wc.hbrBackground,COLOR_BTNFACE+1
		mov	wc.lpszMenuName,IDR_MAINMENU
		mov	wc.lpszClassName,offset szClassName
		invoke LoadIcon,NULL,IDI_APPLICATION
		mov 	wc.hIcon,eax
		mov 	wc.hIconSm,eax
		invoke LoadCursor,NULL,IDC_ARROW
		mov	wc.hCursor,eax
		invoke RegisterClassEx,addr wc
		invoke CreateWindowEx,NULL,offset szClassName,offset szAppName,
			WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN,
			CW_USEDEFAULT,CW_USEDEFAULT,
			MAIN_WINDOW_W,480,NULL,NULL,
			hInst,IDR_MAINMENU
		invoke ShowWindow,hMainWnd,SW_SHOWNORMAL
		;invoke UpdateWindow,hMainWnd

	@@:
		invoke GetMessage,addr msg,NULL,0,0
		or	eax,eax
		jz @F
			invoke TranslateMessage,addr msg
			invoke DispatchMessage,addr msg
		jmp @B
	@@:
		mov	eax,msg.wParam
		ret
WinMain		ENDP

WndProc		PROC hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	
		mov	eax,uMsg

	@WM_DESTROY: ;----------------
		cmp	eax,WM_DESTROY
		jnz @WM_CREATE
			invoke EasySound_Stop
			invoke FreeSDraw
			invoke GlobalFree,lpBufferStart
			invoke PostQuitMessage,NULL
			jmp @End
	@WM_CREATE: ;-----------------
		cmp	eax,WM_CREATE
		jnz @WM_COMMAND
			invoke InitSDraw,1024,768		; init gfx
			m2m	hMainWnd,hWnd

			invoke GlobalAlloc,GPTR,size WNDCLASSEX
			push	eax
			invoke GetClassInfoEx,hInstance,offset szEditClass,eax
			pop	eax
			m2m	lpDefEditProc,(WNDCLASSEX PTR [eax]).lpfnWndProc
			invoke GlobalFree,eax

			invoke initSound
			invoke canvasRegister
			invoke createScope

			jmp @End
	@WM_COMMAND: ;----------------
		cmp	eax,WM_COMMAND
		jnz @WM_GETMINMAXINFO
			mov	eax,wParam

			cmp	eax,IDM_EXIT
			jnz @IDM_SETUP
				invoke PostQuitMessage,NULL
				jmp @End
		@IDM_SETUP: ;----------------
			cmp	eax,IDM_SETUP
			jnz @IDM_OSC
				invoke switchPanel,IDM_SETUP,PANEL_SETUP_H
				jmp @Default
		@IDM_OSC: ;------------------
			cmp	eax,IDM_OSC
			jnz @IDM_FILTER
				invoke switchPanel,IDM_OSC,PANEL_OSC_H
				jmp @Default
		@IDM_FILTER: ;---------------
			cmp	eax,IDM_FLT
			jnz @IDM_SEQ
				not	dFilterOn
				jmp @End
		@IDM_SEQ: ;------------------
			cmp	eax,IDM_SEQ
			jnz @IDM_ABOUT
				invoke switchPanel,IDM_SEQ,PANEL_SEQ_H
				jmp @End
		@IDM_ABOUT: ;----------------
			cmp	eax,IDM_ABOUT
			jnz @Default
				invoke DialogBoxParam,hInstance,IDD_ABOUT,hMainWnd,offset aboutDialog,NULL
				jmp @End
	@WM_GETMINMAXINFO: ;----------
		cmp	eax,WM_GETMINMAXINFO
		jnz @WM_WINDOWPOSCHANGING
			mov	eax,lParam
			mov	(MINMAXINFO PTR [eax]).ptMaxTrackSize.x,1024
			mov	(MINMAXINFO PTR [eax]).ptMaxTrackSize.y,768
			mov	(MINMAXINFO PTR [eax]).ptMinTrackSize.x,640
			mov	(MINMAXINFO PTR [eax]).ptMinTrackSize.y,240
			jmp @Default
	@WM_WINDOWPOSCHANGING:
		cmp	eax,WM_WINDOWPOSCHANGING
		jnz @WM_SIZE
			mov	ecx,lParam
			invoke GetClientRect,hWnd,offset Rect
			jmp @Default
	@WM_SIZE: ;-------------------
		cmp	eax,WM_SIZE
		jnz @Default

			push	DWORD PTR FALSE
			sub	esp,sizeof RECT
			invoke GetClientRect,hWnd,esp
			mov	eax,(RECT PTR [esp]).bottom
			sub	eax,Rect.bottom
			add	eax,scope.h
			mov	(RECT PTR [esp]).bottom,eax
			;m2m	scope.x,(RECT PTR [esp]).left
			;m2m	scope.y,(RECT PTR [esp]).top
			m2m	(RECT PTR [esp]).top,scope.y
			m2m	(RECT PTR [esp]).left,scope.x
			m2m	scope.w,(RECT PTR [esp]).right
			m2m	scope.h,(RECT PTR [esp]).bottom
			push	scope.hWnd
			call MoveWindow

	@Default:
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	@End:
		xor eax,eax
		ret
WndProc		ENDP





setFloatInput	PROC hDlg:HWND,dwDlgItemID:DWORD,lpHandle:DWORD,lpStruct:DWORD

		invoke GetDlgItem,hDlg,dwDlgItemID
		;mov	edx,lpHandle
		mov	hDlg,eax
		;mov	[edx],eax
		invoke SetWindowLong,hDlg,GWL_WNDPROC,offset floatEditProc
		invoke SetWindowLong,hDlg,GWL_USERDATA,lpStruct

		ret
setFloatInput	ENDP

floatEditProc	PROC USES ebx hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

		invoke GetWindowLong,hWnd,GWL_USERDATA
		mov	ebx,eax
		mov	eax,uMsg
		mov	ecx,wParam
		cmp	eax,WM_KEYDOWN
		jnz @WM_CHAR
			cmp	ecx,VK_BACK
			jz @Default
			cmp	ecx,VK_TAB
			jz @Default
			cmp	ecx,VK_RETURN
			jz @@1
			cmp	ecx,VK_PRIOR
			jnz @F
				; PGUP
		@valueUp:
				invoke GetWindowLong,hWnd,GWL_USERDATA
				sub	esp,4
				fld	(POT PTR [ebx]).fValue
				fadd	(POT PTR [ebx]).fStep
				fstp	REAL4 PTR [esp]
				invoke setValue,eax,[esp]
				add	esp,4
				jmp @@3
		@@:
			cmp	ecx,VK_NEXT
			jnz @F
				; PGDN
		@valueDn:

				invoke GetWindowLong,hWnd,GWL_USERDATA
				sub	esp,4
				fld	(POT PTR [ebx]).fValue
				fsub	(POT PTR [ebx]).fStep
				fstp	REAL4 PTR [esp]
				invoke setValue,eax,[esp]
				add	esp,4
			@@3:
				sub	esp,8
				mov	edx,esp
				mov	eax,esp
				push	ecx
				add	edx,4
				invoke SendMessage,hWnd,EM_GETSEL,eax,edx
				pop	ecx
				invoke R4toA,(POT PTR [ecx]).fValue,lpStr,(POT PTR [ecx]).dwPrecision
				invoke SetWindowText,hWnd,lpStr
					push	DWORD PTR EM_SETSEL
					push	hWnd
					call SendMessage
				jmp @End
		@@:
			cmp	ecx,VK_END
			jc @End
			cmp	ecx,VK_DOWN
			ja @F
				jmp @Default
		@@:
			cmp	ecx,VK_DELETE
			jnz @End
				jmp @@1
	@WM_CHAR:
		cmp	eax,WM_CHAR
		jnz @WM_MOUSEWHEEL
			cmp	ecx,0Dh
			jz @@1
			cmp	ecx,'-'
			jnz @F
				test (POT PTR [ebx]).fValue,80000000h	; already negativ?
				jnz @End
					jmp @@1
		@@:
			cmp	ecx,08h
			jz @@1
			cmp	ecx,09h
			jz @Default
			cmp	ecx,'.'
			jz @Default
			cmp	ecx,','
			jnz @F
				mov	wParam,'.'
				jmp @Default
		@@:
			cmp	ecx,'0'
			jc @End
			cmp	ecx,'9'
			ja @End
		@@1:
			invoke CallWindowProc,lpDefEditProc,hWnd,uMsg,wParam,lParam
			sub	esp,4
			invoke SendMessage,hWnd,WM_GETTEXT,32,lpStr
			invoke AtoR4,lpStr,esp
			invoke GetWindowLong,hWnd,GWL_USERDATA
			invoke setValue,eax,[esp]
			add	esp,4
			jmp @@3
	@WM_MOUSEWHEEL:
		cmp	eax,WM_MOUSEWHEEL
		jnz @Default
			test	wParam,080000000h
			jnz @valueDn
				jmp @valueUp
@End:
		xor	eax,eax
		jmp @F
@Default:
		invoke CallWindowProc,lpDefEditProc,hWnd,uMsg,wParam,lParam
@@:
		ret

floatEditProc	ENDP



scopeDraw	PROC USES ebx edi esi hWnd:DWORD,lpScope:DWORD
LOCAL x1:DWORD,x2:DWORD,y1:DWORD,y2:DWORD
; draw sample
		mov	ebx,scope.h
		mov	edi,lpBufferStart
		shr	ebx,1
		mov	edx,dwScopeWindowW	; canvas width - dx
		mov	y2,ebx
		xor	ebx,ebx			; fraction is 0
		mov	ecx,scope.w		; dwDuration in 0.1 secs - dy
		mov	x1,ebx
		mov	x2,ebx
		mov	esi,edx
		sub	ebx,edx
		shl	ecx,1
		shl	edx,1
		add	ebx,ecx			; fraction = 2*dy-dx
	@s1:
		cmp	ebx,0			; fraction >=0
		jnge @s11
			sub	ebx,edx
			mov	ax,[edi]
			movsx	eax,WORD PTR [edi]
			push	ecx
			push	edx
;			or	ax,ax
;			jns @F
;			or	eax,0FFFF0000h
;		@@:
			mov	ecx,scope.h
			imul	ecx
			push	ecx
			mov	ecx,0FFFFh
			idiv	ecx
			pop	ecx
			shr	ecx,1
			add	eax,ecx
				invoke sDrawLine,x2,y2,x1,eax,COLOR_ACTIVE_CURVE
				;invoke sdSetPixel,x1,eax,COLOR_ACTIVE_CURVE
				add	x1,1
		@@:
			m2m	x2,x1
			mov	y2,eax
			pop	edx
			pop	ecx

	@s11:
		add	edi,2
		add	ebx,ecx		; fraction+=dy
		sub	esi,1		; x0+=step
		jnz @s1

		ret

scopeDraw	ENDP

scopeProc	PROC USES ebx esi edi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

		.IF uMsg==WM_TIMER
			jmp @Paint
		.ELSE
			invoke canvasProc,hWnd,uMsg,wParam,lParam
			.IF uMsg==WM_SIZE
				jmp @Paint
			.ELSEIF uMsg==WM_PAINT
	@Paint: 	
				invoke sdStart,hWnd
				or 	eax,eax
				jz @End
					mov	eax,dwSampleRate
					mov	ecx,0100h
					xor	edx,edx
					div	ecx
					invoke canvasDrawBack,hWnd,dwScopeWindowW,eax,256,64
					mov	eax,scope.h
					shr	eax,1
					invoke sDrawLineH,0,eax,canvasRect.right,COLOR_ACTIVE_GRIDLINE
					invoke scopeDraw,hWnd,offset scope

				invoke ValidateRect,hWnd,NULL
				invoke sdEnd
			.ELSE
				invoke	DefWindowProc,hWnd,uMsg,wParam,lParam
				ret
			.ENDIF
		.ENDIF
	@End:
		xor	eax,eax
		ret

scopeProc	ENDP

createScope	PROC

		invoke GetClientRect,hMainWnd,offset Rect
		mov	scope.ID,IDC_SCOPE
		m2m	scope.hParent,hMainWnd
		m2m	scope.hInstance,hInstance
		mov	scope.x,0
		mov	scope.y,0
		m2m	scope.w,Rect.right
		m2m	scope.h,Rect.bottom
		mov	scope.object,NULL
		m2m	scope.lpWndProc,offset scopeProc
		invoke canvasCreate,offset scope
		
		invoke SetTimer,scope.hWnd,IDT_SCOPE,dwScopeRate,NULL
		ret
createScope	ENDP




setupProc	PROC hDlg:HWND,uMsg:DWORD,wParam:DWORD,lParam:DWORD

		.IF uMsg==WM_INITDIALOG
			m2m	hPanel,hDlg
			invoke MoveWindow,hDlg,0,0,PANEL_SETUP_W,PANEL_SETUP_H,TRUE
			invoke SetDlgItemInt,hDlg,IDC_LATENCY,EasySound_Latency,FALSE
			invoke SetDlgItemInt,hDlg,IDC_SCOPERATE,dwScopeRate,FALSE
			xor	eax,eax
		.ELSEIF uMsg==WM_COMMAND
			.IF wParam==IDC_LATENCY+10000h*EN_CHANGE
				invoke GetDlgItemInt,hDlg,IDC_LATENCY,NULL,FALSE
				mov	EasySound_Latency,eax
			.ELSEIF wParam==IDC_SCOPERATE+10000h*EN_CHANGE
				invoke GetDlgItemInt,hDlg,IDC_SCOPERATE,NULL,FALSE
				mov	dwScopeRate,eax
				invoke KillTimer,scope.hWnd,IDT_SCOPE
				invoke SetTimer,scope.hWnd,IDT_SCOPE,dwScopeRate,NULL
			.ENDIF
			xor	eax,eax
		.ELSEIF uMsg==WM_CLOSE
			invoke EndDialog,hDlg,NULL
		.ELSE
			xor	eax,eax
		.ENDIF

		ret

setupProc	ENDP

aboutDialog	PROC hDlg:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

		.IF uMsg==WM_INITDIALOG
			invoke GetWindowRect,hMainWnd,offset Rect
			mov	eax,Rect.right
			mov	ecx,Rect.top
			add	eax,Rect.left
			add	ecx,Rect.bottom
			sub	eax,280
			sub	ecx,144
			shr	eax,1
			shr	ecx,1
			invoke SetWindowPos,hDlg,HWND_NOTOPMOST,eax,ecx,0,0,SWP_NOSIZE
			xor	eax,eax
		.ELSEIF uMsg==WM_CLOSE
			jmp @F
		.ELSEIF uMsg==WM_COMMAND
	@@:
			invoke EndDialog,hDlg,NULL			
		.ELSE
			xor	eax,eax
		.ENDIF

		ret

aboutDialog	ENDP

soundCallBack	PROC lpBuffer:DWORD,dwNumOfSamples:DWORD


		mov	ebx,dwNumOfSamples
		mov	edi,lpBuffer
	@loop:
		invoke synth

		add	edi,2
		sub	ebx,1
		jnz @loop

		mov	ecx,dwNumOfSamples
		mov	esi,lpBuffer
		mov	edi,lpBufferGenPos
		shr	ecx,1
		rep movsd

		cmp	edi,lpBufferEnd
		jc @F
			mov	edi,lpBufferStart
	@@:
		mov	lpBufferGenPos,edi

;		mov	esi,lpBufferPlayPos
;		shr	ecx,1
;		rep	movsd
;		cmp	esi,lpBufferEnd
;		jc @F
;			mov	esi,lpBufferStart
;	@@:
;		mov	lpBufferPlayPos,esi
;		mov	ebx,dwNumOfSamples
;		mov	edi,lpBufferGenPos

		
		ret

soundCallBack	ENDP

initSound	PROC USES edi
		mov	ecx,BUFFER_SIZE
		shl	ecx,1
		invoke GlobalAlloc,GPTR,ecx
		mov	lpBufferStart,eax
		mov	lpBufferGenPos,eax
		mov	edi,eax
		add	eax,BUFFER_SIZE
		mov	lpBufferPlayPos,eax
		add	eax,BUFFER_SIZE
		mov	lpBufferEnd,eax
		mov	ecx,BUFFER_SIZE/4
		xor	eax,eax
		rep	stosd
		mov	EasySound_Latency,3000

		invoke EasySound_Start,offset soundCallBack,dwSampleRate,1,0

		ret
initSound	ENDP




switchPanel	PROC dwPanelID:DWORD,dwPanelHeight:DWORD

		mov	eax,dwPanelID
		xor	edx,edx
		.IF dwPanel==IDM_SETUP
			mov	edx,PANEL_SETUP_H
			.IF eax==IDM_SETUP
				xor	eax,eax
			.ENDIF
		.ELSEIF dwPanel==IDM_OSC
			mov	edx,4*PANEL_OSC_H
			.IF eax==IDM_OSC
				xor	eax,eax
			.ENDIF
		.ELSEIF dwPanel==IDM_SEQ
			mov	edx,PANEL_SEQ_H
			.IF eax==IDM_SEQ
				xor	eax,eax
			.ENDIF
		.ENDIF
		add	scope.h,edx
		sub	scope.y,edx
		.IF edx
			push	eax
			mov	edx,offset hPanel
			mov	ecx,4*4
		@@:
			.IF DWORD PTR [hPanel+ecx-4] != 0
				push	ecx
				invoke SendMessage,[hPanel+ecx-4],WM_CLOSE,0,0
				pop	ecx
			.ENDIF
			sub	ecx,4
			jnz @B
			pop	eax
		.ENDIF
		push	eax
		xor	edx,edx
		.IF eax==IDM_SETUP
			invoke CreateDialogParam,hInstance,IDD_SETUP,hMainWnd,offset setupProc,NULL
			mov	edx,PANEL_SETUP_H
		.ELSEIF eax==IDM_OSC
			invoke CreateDialogParam,hInstance,IDD_OSC,hMainWnd,offset oscProc,0
			invoke CreateDialogParam,hInstance,IDD_OSC,hMainWnd,offset oscProc,1
			invoke CreateDialogParam,hInstance,IDD_OSC,hMainWnd,offset oscProc,2
			invoke CreateDialogParam,hInstance,IDD_OSC,hMainWnd,offset oscProc,3
			mov	edx,4*PANEL_OSC_H
		.ELSEIF eax==IDM_SEQ
			invoke CreateDialogParam,hInstance,IDD_SEQ,hMainWnd,offset seqProc,NULL
			mov	edx,PANEL_SEQ_H
		.ENDIF

		sub	scope.h,edx
		add	scope.y,edx
		invoke MoveWindow,scope.hWnd,scope.x,scope.y,scope.w,scope.h,FALSE
		invoke InvalidateRect,hMainWnd,NULL,TRUE
		pop	dwPanel
		ret

switchPanel	ENDP


synth		PROC USES esi
	
		add	dwLoops,1
		;counter_begin 1,HIGH_PRIORITY_CLASS
		;pushad

		.IF add1.op2.lpOutput != 0
			invoke add2Run,offset add1
		.ENDIF
		.IF add2.op2.lpOutput != 0
			invoke add2Run,offset add2
		.ENDIF
		.IF add3.op2.lpOutput != 0
			invoke add2Run,offset add3
		.ENDIF
		.IF add4.op2.lpOutput != 0
			invoke add2Run,offset add4
		.ENDIF

		fldz
		.IF osc1.dwOn
			push	offset osc1
			call	DWORD PTR osc1.lpRun
			.IF osc1.dwRouteMdl == 0
				fadd	REAL4 PTR osc1.fValue
			.ENDIF
		.ENDIF
		.IF osc2.dwOn
			push	offset osc2
			call	DWORD PTR osc2.lpRun
			.IF osc2.dwRouteMdl == 0
				fadd	REAL4 PTR osc2.fValue
			.ENDIF

		.ENDIF
		.IF osc3.dwOn
			push	offset osc3
			call	DWORD PTR osc3.lpRun
			.IF osc3.dwRouteMdl == 0
				fadd	REAL4 PTR osc3.fValue
			.ENDIF
		.ENDIF
		.IF osc4.dwOn
			push	offset osc4
			call	DWORD PTR osc4.lpRun
			.IF osc4.dwRouteMdl == 0
				fadd	REAL4 PTR osc4.fValue
			.ENDIF
		.ENDIF

		.IF dFilterOn
			invoke filterRun,offset filter1
		.ENDIF

		add	dwGenCycles,eax

		fld	fMaxAmp
		fmul	st(1),st
		fld	fMaxAmp
		fchs
	; st(0): -maxAmp
	; st(1): maxAmp
	; st(2): sample
		fcomp	st(2)
		fstsw	ax
		sahf
		jc @1
;PrintText "-clip"
			fstp	st
			fstp	st
			mov	WORD PTR [edi],08000h
			jmp @3
	@1:
		fcomp	st(1)
		fstsw	ax
		sahf
		jnc @2
;PrintText "+clip"
			fstp	st
			mov	WORD PTR [edi],07FFFh
			jmp @3
	@2:
		fistp	WORD PTR [edi]
	@3:

		;popad
		;counter_end
		ret

synth		ENDP


end start